package com.perforce.workshop.tjuricek.p4oauth.test_server;

import java.net.InetAddress;
import java.net.UnknownHostException;

/**
 */
public class Conventions {

    public static String getRedirectUri(String hostname, int port) {
        return String.format("https://%s:%d/handle", hostname, port);
    }

    public static String getHostname() {
        String hostname = null;
        if (System.getProperty("COMPUTERNAME") != null) {
            hostname = System.getProperty("COMPUTERNAME"); // Windows
        } else if (System.getProperty("HOSTNAME") != null) {
            hostname = System.getProperty("HOSTNAME"); // Unix, sometimes
        }
        if (hostname == null) {
            try {
                hostname = InetAddress.getLocalHost().getHostName();
            } catch (UnknownHostException e) {
                // Ignore, we just don't know it by default
            }
        }
        return hostname;
    }
}
