package com.perforce.workshop.tjuricek.p4oauth.config;

import com.perforce.workshop.tjuricek.p4oauth.controllers.LoginGet;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

/**
 */
public class UrlFactory {

    private P4OAuthConfig config;

    public UrlFactory(P4OAuthConfig config) {
        this.config = config;
    }

    public P4OAuthConfig getConfig() {
        return config;
    }

    public void setConfig(P4OAuthConfig config) {
        this.config = config;
    }

    public String getLoginUrl(String login, String redirectUri, String state) {
        try {
            return getP4OAuthUrl() + LoginGet.LOGIN_PATH + "?"
                    + "client_id=" + login + "&"
                    + "redirect_uri=" + URLEncoder.encode(redirectUri, "utf8")
                    + (state != null ? "&state=" + URLEncoder.encode(state, "utf8") : "");
        } catch (UnsupportedEncodingException e) {
            throw new IllegalStateException(e);
        }
    }

    public String getP4OAuthUrl() {
        StringBuilder url = new StringBuilder();
        url.append("https://");
        url.append(config.getHostname());

        if (config.getHttpsPort() != 443) {
            url.append(":").append(config.getHttpsPort());
        }

        if (config.getContextRoot() != null) {
            url.append(config.getContextRoot());
        }

        return url.toString();
    }

    public String createAuthRedirect(String redirectUri, String code, String state) {
        try {
            return redirectUri + "?" +
                    "code=" + URLEncoder.encode(code, "utf8") +
                    (state != null ? "&state=" + URLEncoder.encode(state, "utf8") : "");
        } catch (UnsupportedEncodingException e) {
            throw new IllegalStateException(e);
        }
    }
}
