package com.perforce.workshop.tjuricek.p4oauth.models;

import java.util.List;

/**
 */
public class Whitelist {

    private List<WhitelistedServer> servers;

    public List<WhitelistedServer> getServers() {
        return servers;
    }

    public void setServers(List<WhitelistedServer> servers) {
        this.servers = servers;
    }

    public boolean isWhitelisted(String redirectUri) {
        return this.servers.stream()
                .filter(s -> redirectUri.equals(s.getRedirectUri()))
                .findFirst()
                .isPresent();
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Whitelist whitelist = (Whitelist) o;

        if (servers != null ? !servers.equals(whitelist.servers) : whitelist.servers != null)
            return false;

        return true;
    }

    @Override
    public int hashCode() {
        return servers != null ? servers.hashCode() : 0;
    }

    @Override
    public String toString() {
        return "Whitelist{" +
                "servers=" + servers +
                '}';
    }
}
